//+------------------------------------------------------------------+ 
//|   TRO_Turn                                                       | 
//|                                                                  | 
//|   Copyright  2010, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2010, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/"
 
//+------------------------------------------------------------------+
  
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Red 
 

extern bool   Show_Shade   = true ;
extern bool   bDrawBoxes   = true;



extern   int myBarWidth = 0;
extern int   myBoxWidth       = 3;


extern color myBarColorUp   = Blue;
extern color myBarColorDown = Red;

extern color colorBuyShade     = Navy ;//MintCream PowderBlue
extern color colorShortShade   = FireBrick ; // MistyRose



//---- buffers
double val1[];
double val2[];
double val3[];
double val4[];
 

double  point, cVal = 0, pVal = 0  ;
string symbol, tChartPeriod,  tShortName ;  
int    digits, period , vDigits ; 

   int limit, counted_bars;
    

int indexL, indexH   ;


string TAG = "TURN" ; 
string tRes0 =  "Res_0" ;
string tSup0 =  "Sup_0" ;
string tLgTrig =  "LgTrig_0" ;
string tShTrig =  "ShTrig_0" ;
 
 
//+------------------------------------------------------------------+
int init()
  {


   period       = Period() ;   
//   tChartPeriod = TimeFrameToString(period) ;
   symbol       = Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
        

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }
   
   
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
   
   SetIndexBuffer(2,val3);
   SetIndexBuffer(3,val4);
      
         
   SetIndexStyle(0,DRAW_HISTOGRAM,0,myBarWidth,myBarColorUp);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,myBarWidth,myBarColorUp);
         
   SetIndexStyle(2,DRAW_HISTOGRAM,0,myBarWidth,myBarColorDown);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,myBarWidth,myBarColorDown);   

    tRes0 = TAG + "Res_0" ;
    tSup0 = TAG + "Sup_0" ;
    tLgTrig = TAG + "LgTrig_0" ;
    tShTrig = TAG + "ShTrig_0" ;


   deinit();
//----
   return(0);
  } 
  

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
  
   ObDeleteObjectsByPrefix(TAG);  
   
      TRO() ;
   
   return(0);
}

//+------------------------------------------------------------------+
int start()
{

   counted_bars = IndicatorCounted();
 
   if(counted_bars>0) counted_bars--;
   limit = Bars-counted_bars;
 
   for(int i = 1; i < limit ; i++)
   {     

          val1[i] = EMPTY_VALUE; 
          val2[i] = EMPTY_VALUE;
          val3[i] = EMPTY_VALUE; 
          val4[i] = EMPTY_VALUE;
   
      if( Low[i] < Low[i+1] && Close[i] > Open[i] ) 
      {
          val1[i] = Low[i]; 
          val2[i] = High[i];
      }
      else
      if( High[i] > High[i+1] && Close[i] < Open[i] ) 
      {
          val3[i] = Low[i]; 
          val4[i] = High[i];
      }      
      
      
   }


        indexL = 0 ;
        indexH = 0 ;
 
        for( int s=0;s<100;s++)
        {
            if(val1[s] != EMPTY_VALUE) { indexL = s   ;  break ;  }  
        }
        
        for( s=0;s<100;s++)
        {
            if(val3[s] != EMPTY_VALUE) { indexH = s  ;  break ;} 
        } 

      if( bDrawBoxes )  { DoDrawBoxes(); }       

      if(Show_Shade) { DoShowShade(); }
      

   
   return(0);
  } 

//+--------- TRO MODIFICATION ---------------------------------------+  
void DoShowShade()    
{
 


        if (ObjectFind(TAG+"09") != 0)
        ObjectCreate(TAG+"09", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(TAG+"09", OBJPROP_TIME1, Time[0]);
        ObjectSet(TAG+"09", OBJPROP_PRICE1, val1[indexL]);
        ObjectSet(TAG+"09", OBJPROP_TIME2, Time[indexL]);
        ObjectSet(TAG+"09", OBJPROP_PRICE2, val2[indexL]);
        ObjectSet(TAG+"09", OBJPROP_COLOR, colorBuyShade);
        ObjectSet(TAG+"09", OBJPROP_BACK, true);
  
        if (ObjectFind(TAG+"10") != 0)
        ObjectCreate(TAG+"10", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(TAG+"10", OBJPROP_TIME1, Time[0]);
        ObjectSet(TAG+"10", OBJPROP_PRICE1, val3[indexH]);
        ObjectSet(TAG+"10", OBJPROP_TIME2, Time[indexH]);
        ObjectSet(TAG+"10", OBJPROP_PRICE2, val4[indexH]);
        ObjectSet(TAG+"10", OBJPROP_COLOR, colorShortShade);
        ObjectSet(TAG+"10", OBJPROP_BACK, true);
        
              
}

//+------------------------------------------------------------------+


void DoDrawBoxes()   
{
/*
  if (ObjectFind(tRes0) != 0)
      {
          ObjectCreate(tRes0,OBJ_ARROW,0,Time[0],val4[indexH]);
          ObjectSet(tRes0,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tRes0,OBJPROP_COLOR,myBarColorDown);  
          ObjectSet(tRes0,OBJPROP_WIDTH,myBoxWidth);             
      } 
      else
      {
         ObjectMove(tRes0,0,Time[0],val4[indexH]);
      }

  if (ObjectFind(tSup0) != 0)
      {
          ObjectCreate(tSup0,OBJ_ARROW,0,Time[0],val1[indexL]);
          ObjectSet(tSup0,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tSup0,OBJPROP_COLOR,myBarColorUp);  
          ObjectSet(tSup0,OBJPROP_WIDTH,myBoxWidth);           
      } 
      else
      {
         ObjectMove(tSup0,0,Time[0],val1[indexL]);
      }
*/      
      

   ObjectDelete(tLgTrig);    
   
  if (ObjectFind(tLgTrig) != 0)
      {
          ObjectCreate(tLgTrig,OBJ_ARROW,0,Time[0],val2[indexL]);
          ObjectSet(tLgTrig,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLgTrig,OBJPROP_COLOR,myBarColorUp); 
          ObjectSet(tLgTrig,OBJPROP_WIDTH,myBoxWidth);             
      } 
      else
      {
         ObjectMove(tLgTrig,0,Time[0],val2[indexL]);
      }
      
  if (ObjectFind(tShTrig) != 0)
      {
          ObjectCreate(tShTrig,OBJ_ARROW,0,Time[0],val3[indexH]);
          ObjectSet(tShTrig,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShTrig,OBJPROP_COLOR,myBarColorDown);  
          ObjectSet(tShTrig,OBJPROP_WIDTH,myBoxWidth);            
      } 
      else
      {
         ObjectMove(tShTrig,0,Time[0],val3[indexH]);
      }     
 
 

} 

  
//+------------------------------------------------------------------+  
 
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+
/*

  Comment(
   "indexL = ", indexL , "\n",
   "indexH = ", indexH , "\n",  
   "") ;   
  

   static datetime prevtime = 0;
 
 
     
   if(prevtime == Time[0]) { return(0); }
   
   prevtime = Time[0];

*/